const browserType = document.querySelector('html').dataset.browseMode;
const parentElm = document.querySelectorAll('.block-parallax');
const textContElm = document.querySelectorAll('.block-content-wrap');
const childElm = document.querySelectorAll('.parallax-inner:not(.auto-playback):not(.js-prllx-bg)');
let firstCount = 0;

// --------------- パララックス終了監視
const endHeader = document.querySelector('.pane-header');
let endCount = 0;
const fadeInOptions2 = {
  root: null,
  rootMargin: '0px',
  threshold: 0.3,
};
const observer2 = new IntersectionObserver((entries, observer) => {
  entries.forEach(entry => {
    if (entry.isIntersecting) {
      endHeader.classList.add('active');
      document.querySelector('.c-menu').classList.remove('is-show');
      observer2.unobserve(entry.target);
      endCount++;
    }
  });
}, fadeInOptions2);
if (browserType === 'S') {
  // SPのとき
  const endParallax = document.querySelector('.block-item-detail .item-info-detail');
  observer2.observe(endParallax);
} else {
  // PCのとき
  const endParallax = document.querySelector('.block-item-detail');
  observer2.observe(endParallax);
}
// --------------- SPのみ：テキストコンテント監視
  const innerText = document.querySelectorAll('.text-content .is-text');
  const fadeInOptions3 = {
    root: null,
    rootMargin: '-35%',
  };
  const Options3Threshold = 1.0;
  const parallaxOptions3Threshold = 0.8;
  const observer3 = new IntersectionObserver((entries, observer) => {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        entry.target.closest('.block-content-wrap').querySelector('.block-fixed-cart').classList.add('active');
      } else {
        entry.target.closest('.block-content-wrap').querySelector('.block-fixed-cart').classList.remove('active');
      }
    });
  }, fadeInOptions3);

// --------------- 親要素監視
const fadeInOptions = {
  root: null,
  rootMargin: '0px',
  threshold: 0.25,
};
const fadeInObserver = new IntersectionObserver((entries, observer) => {
  const getFirstElm = entries;
  entries.forEach((entry) => {
    if (entry.isIntersecting) {
      // 表示するとき
      if (entry.target.classList.contains('slide-text')){
        document.querySelector('.fl-banner').classList.remove('is-show');
      }
      if (entry.target.classList.contains('movie')){
        document.querySelector('.c-menu').classList.remove('is-show');
      }
      if (entry.target.classList.contains('movie')){
        document.querySelector('.fl-banner').classList.add('is-show');
      }
      if (entry.target.classList.contains('block-slide-area')){
        document.querySelector('.c-menu').classList.add('is-show');
      }
      entry.target.classList.add('active');
      addClassWithDelay(entry.target);
      
      // 初回表示時
      if(entry.target.classList.contains('parallax-inner')) {
        entry.target.classList.add('already');
      }
      
      // また見るとき
      if(endCount > 0) {
        if (browserType === 'S') {
          // SPのとき
          const endParallax = document.querySelector('.block-item-detail .item-info-detail');
          observer2.observe(endParallax);
        } else {
          // PCのとき
          const endParallax = document.querySelector('.block-item-detail');
          observer2.observe(endParallax);
        }
        endHeader.classList.remove('active');
        document.querySelector('.c-menu').classList.add('is-show');
        endCount = 0;

      }

    } else {
      entry.target.classList.remove('active');
      if(!entry.target.classList.contains('point-list') && browserType === 'S') {
        document.querySelector('body').classList.remove('is-fixed');
      }

    }
  });
}, fadeInOptions);

// --------------- 初期表示（自動再生）
const actions = [
  { delay: 0, selector: '.js-prllx-bg' },
  { delay: 1500, selector: '.poition-bg'},
  { delay: 200, selector: '.auto-playback'}
];
async function addClassWithDelay(target) {
  for (const action of actions) {
    await new Promise((resolve) => setTimeout(resolve, action.delay));
    target.querySelector(action.selector)?.classList.add('active');
  }
}

// --------------- リサイズ監視
function gcd(x, y){
  if(y === 0) return x
  return gcd(y, x % y)
}

// --------------- 初期表示
document.querySelector('body').classList.add('is-fixed');

// --------------- ローディング画面
window.addEventListener('load', () => {
    document.querySelector('body').classList.remove('is-fixed');
    // 発火
    parentElm.forEach((elm) => fadeInObserver.observe(elm,{
      attributes: true,
      childList: true
    }));
    childElm.forEach((elm) => fadeInObserver.observe(elm,{
      attributes: true,
      childList: true
    }));

});

//----------- フローティングバナー
jQuery('.fl-banner .close').click(function(){
  jQuery(this).parent('.fl-banner').addClass('hide');
});
jQuery('.js-slider').slick({
  infinite:true,
  arrows: true,
  dots: false,
  autoplay: true,
  speed: 1000,
  autoplaySpeed: 3000,
  slidesToShow: 1,
  centerMode: true,
});
if (jQuery('[data-browse-mode="S"]').length) {
  jQuery(window).on('scroll', function () {
    if (jQuery('header').hasClass('is-fixed')) {
      let hHeight = jQuery('header').height();
      jQuery('.c-menu').css('top',hHeight);
    }
  }); 
}

//--- フローティングバナーの透過
function ScrollTransparentFnc() {

  let scroll = jQuery(window).scrollTop();
  let banner = jQuery('.fl-banner');

  if( banner.length) {
    if (scroll > 100) {
      banner.addClass('fade')
    } else {
      banner.removeClass('fade')
    }
  }
}
jQuery(window).scroll(function () {
  ScrollTransparentFnc();
});